#! /usr/local/bin/ruby -Ke

require "constant"
require "larnobject"
require "utility"
require "doublearray"
require "random"
require "monster"

include Random if $0 == __FILE__

=begin

xcol,yrow

=end

class Cavelevel

  include Constant::Object
  include Constant::Cavelevel
  include Utility
  
  START = 0

  # LarnκǶƥ(Ϥǹ)Ǥ롢Bessman's flailing hammer
  # ФޤɤΥե饰

  @@bessmann = false

  attr_reader :maze, :objects, :monsters, :players, :spheres
  
  def initialize( level )

    @level    = level    # 
       
    # Ϸǡɽ롣
    # @maze[ row ][ col ] == ONOTHING : [ row, col ]ϩ
    # @maze[ row ][ col ] == OWALL :    [ row, col ]ɡ

    @maze = Doublearray.new( MAXY, MAXX,
			    ( @level == START ) ? ONOTHING : OWALL )
  
    @objects  = {}
    @monsters = {}
    @players  = {}
    @spheres  = {}
    
    make_maze
    fill_monsters
    makeobject

    @already_join = []
    
  end

  def join( player )
    @already_join.push( player )
  end

  def already_joined?( player )
    @already_join.include?( player )
  end
  
  def leave( player )
    @players.delete_if { | point, another | another == player }
  end
  
  # 餫data fileѰդ줿ǡѤơµܤ롣
  
  def cannedlevel?

    return false if ( @level <= 1 )
    return( rnd( 17 ) <= 4  || @level == MAXLEVEL - 1 || @level == MAXLEVEL + MAXVLEVEL-1 )
  
  end

  # larnmazeեƤµܤϡ16ࡣ
  # 18Ԥġ
  
  LARNMAZE = "larnmaze"

  def do_cannedlevel( row, col, byte )
    
    if byte == ?\#
      @maze[ row ][ col ] = OWALL
      return
    end

    @maze[ row ][ col ] = ONOTHING
    point = [ row, col ]
    
    
    case byte
    when ?D
      @objects[ point ] = Larnobject.new( OCLOSEDDOOR, rand( 30 ) )
    when ?~
      return unless ( @level == MAXLEVEL - 1 )

      # The Eye of Larn֤ǡ򥬡ǥȤ֡
      @objects[ point ]  = Larnobject.new( OLARNEYE )
      @monsters[ point ] = Monster.random_demon

    when ?!
      return unless ( @level == MAXLEVEL + MAXVLEVEL - 1 )
      
      @objects[ point ]  = Larnobject.new( OPOTION, 21 )
      @monsters[ point ] = Monster.demonprince

    when ?.
      return unless volcano?
      
      @monsters[ point ] = Monster.create( @level + 1 )

    when ?-
      @objects[ point ] = Larnobject.something( @level + 1 )
    end
        
  end

  
  def cannedlevel

    start = rand( 16 ) * 18    
    i = 0
    
    File.foreach( LARNMAZE ) do | line |

      if ( i < start )
	i += 1
	next
      end

      return if ( i > start + MAXY - 1 )

      j = 0
      line.chomp.each_byte do | byte |
	do_cannedlevel( i - start, j, byte ) if j < MAXX
	j += 1
      end
	
      i += 1
            
    end

  end
  
  # /*
  #       function to eat away a filled in maze
  # */

  DIRS  = 4

  WEST  = 1
  EAST  = 2
  NORTH = 3
  SOUTH = 4

  
  def to_eat?( row, col, dir )

    case dir
    when WEST
      return false if ( col <= 2 )
      return ( @maze[row][col-1] == OWALL && @maze[row][col-2] == OWALL )
    when EAST
      return false if ( col >= Constant::MAXX-3 )
      return ( @maze[row][col+1] == OWALL && @maze[row][col+2] == OWALL )
    when NORTH
      return false if ( row <= 2 )
      return ( @maze[row-1][col] == OWALL && @maze[row-2][col] == OWALL )
    when SOUTH
      return false if ( row >= Constant::MAXY-3 )
      return ( @maze[row+1][col] == OWALL && @maze[row+2][col] == OWALL )
    end
    
  end

  def doeat( row, col, dir )
 
    case dir
    when WEST
      @maze[row][col-1] = @maze[row][col-2] = ONOTHING
      eat( row, col - 2 )
    when EAST
      @maze[row][col+1] = @maze[row][col+2] = ONOTHING
      eat( row, col + 2 )
    when NORTH
      @maze[row-1][col] = @maze[row-2][col] = ONOTHING
      eat( row - 2, col )
    when SOUTH
      @maze[row+1][col] = @maze[row+2][col] = ONOTHING
      eat( row + 2, col )
    end
    
  end
  
  # ɤβƵŪڤơץ쥤䡼⤱ƻ( ONOTHING )롣
  
  def eat( row, col )
     
    dir = rnd( DIRS )
    try = 2

    while ( try != 0 )

      doeat( row, col, dir ) if to_eat?( row, col, dir )

      if ( ( dir += 1 ) > DIRS )
	dir = WEST
	try -= 1
      end
      
    end       

  end

  def entrance

    @objects.each do | point, obj |
      next unless obj.entrance?
      return point
    end

    nil
    
  end

 
  def make_maze

    return if ( @level == START )
    
    # /* read maze from data file */
    if ( cannedlevel? )
      cannedlevel
      return
    end

    eat( 1, 1 ) # 󥸥򤯤ȴ
 
    # µܤĹˤȴƤ
    # лµܤξˤϡζ֤󥹥Ԥ
    # row = ( 0 .. 66 ) MAXX = 67
    # col = ( 0 .. 16 ) MAXY = 17
    
    ( rnd( 3 ) + 3 ).times do
      
      my  = rnd( 11 ) + 2 # 3 .. 13
      myl = my - rnd( 2 ) # 1 .. 12
      myh = my + rnd( 2 ) # 4 .. 15

      # 6 .. 49,  4 .. 63
      mx  = ( !volcano? ) ? rnd( 44 ) + 5      : rnd( 60 ) + 3

      # 2 .. 48,  2 .. 62
      mxl = ( !volcano? ) ? mx - rnd( 4 )      : mx - rnd( 2 )

      # 10 .. 64, 5 .. 65
      mxh = ( !volcano? ) ? mx + rnd( 12 ) + 3 : mx + rnd( 2 )
   
      mxl.upto( mxh - 1 ) do | col |
	myl.upto( myh - 1 ) do | row |
	  @maze[ row ][ col ] = ONOTHING
	  next if ( @level < MAXLEVEL )
	  
	  @monsters[ [ row, col ] ] = Monster.create( @level )
	end
      end

    end

    # Хѥ̤
    tmp = rnd( MAXY-2 )
    1.upto( MAXX - 2 ) { | i | @maze[ tmp ][ i ] = ONOTHING  }

    treasureroom
    
  end

  def treasureroom

    return unless ( @level > 1 )
   
    tx = 1 + rnd( 10 )
    
    while ( tx < MAXX - 10 )

      # xsize = rnd( 6 ) + 3         # ( 4 ..  9 )
      # ysize = rnd( 3 ) + 3         # ( 4 ..  6 )
      # ty    = rnd( MAXY - 9 )      # ( 1 ..  8 )  LarnΥǥեȡ
      # ty    = rnd( MAXY - 10 ) + 1 # ( 2 ..  8 )  RubyLarn
      # tx                           # ( 2 .. 56 ) 
      
      if ( rnd( 13 ) == 2 )
	troom( rnd( 3 ) + 3, rnd( 6 ) + 3, rnd( MAXY - 10 ) + 1, tx )
      end

      tx += 10
      
    end

  end
  
  # ʪˤĺ롣
  # rsize, csize : 
  # roff,  coff  : Ԥoffsetɤκ

  # ɤȤäĹɤ롣
  # ٤򷡤롣
  # ɤζ֤Ƥȴ(ONOTHING)
  # ɥ֤롣
  # ζ֤򥢥ƥȥ󥹥Ȥ
  
  #      ########D######
  #      #             #
  #      #             #
  #      #             #
  #      ###############
  
  def troom( rsize, csize, roff, coff )
    
    ( roff - 1 ).upto( roff + rsize ) do | row |
      ( coff - 1 ).upto( coff + csize ) do | col |
	
	if row == roff - 1 || row == roff + rsize ||
	    col == coff - 1 || col == coff + csize  # ١
	  @maze[ row ][ col ] = ONOTHING
	elsif row == roff || row == roff + rsize - 1 ||
	    col == coff || col == coff + csize - 1  # ɡ
	  @maze[ row ][ col ] = OWALL
	else
	  @maze[ row ][ col ] = ONOTHING
	end

      end
    end

    # ɥ־ηꡣ
    
    case ( rnd( 2 ) ) #  /* locate the door on the treasure room */
    when 1
      row = roff + ( rsize - 1 ) * rund( 2 ) # ־夫ֲ
      col = coff + rund( csize )
    else
      row = roff + rund( rsize )
      col = coff + ( csize - 1 ) * rund( 2 ) # 
    end

    @objects[ [ row, col ] ] = Larnobject.new( OCLOSEDDOOR, rand( 9 ) )
    @maze[ row ][ col ] = ONOTHING

    # ˥ƥȡ󥹥ͤ롣
    
    ( coff + 1 ).step( coff + csize - 2, 2 ) do | col |
      ( rnd( 6 ) + 1 ).times do
	
	point = [ roff + ( rsize >> 1 ), col ]

	put_object_near( Larnobject.something( @level + 2 ), point, true )
	put_monster_near( Monster.create( @level + ( ( $HARDGAME > 2 ) ? 1 : 3 ) ), point )
      end
    end
    
  end

  def put_object_near( obj, point, treasure = false )

    return if treasure && obj.junk?
    
    p_point = choose_dir_point( point ) do | _point |
      putable?( _point )
    end

    @objects[ p_point ] = obj if p_point
    p_point
        
  end

  def put_sphere( sphere, point )
    @spheres[ point ] = sphere 
  end

  def move_sphere( sphere, from, to )
    
    @spheres.delete( from ) if from 
    @spheres[ to ] = sphere if to

  end

  def all_spheres
    @spheres.to_a
  end

  def exit
    ( @level == 1 ) ? [ MAXY - 1, 33 ] : nil
   end

  
  def remove_sphere( sphere, point )
    @spheres.delete( point ) if point
  end

  def sphere_alive?( sphere )
    @spheres.value?( sphere )
  end

  # pointsphereȯȤˡplayerޤ뤫ɤ
  def exploded_by_sphere?( player )
    !( @players.value?( player ) )
  end

  alias_method( :annihilated_by_sphere?, :exploded_by_sphere? )

  
  # Ⱦ2ʲΥ󥹥ƥࡢϷsphere᤭Фޤ
  
  def explode_sphere( point, radius = 2, sphere_delete = true )

    @monsters.delete_if { | m_point, | distance( point, m_point ) <= radius }
    @objects.delete_if  { | o_point, | distance( point, o_point ) <= radius }
 
    if sphere_delete
      @spheres.delete_if  { | s_point, | distance( point, s_point ) <= radius }
    end
      
    wall_crumbles_radius( point, radius )

  end

  def to_be_annihilated( point, radius = 0 )
    p_dup = @players.dup
    p_dup.delete_if { | p_point, | distance( point, p_point ) > radius }
    p_dup.to_a
  end
  
  def to_be_exploded( point ) 
    to_be_annihilated( point, radius = 2 )
  end
  
  def annihilated( point )
    explode_sphere( point, 0, false )
  end
  

  def home_exists?
    @objects.find { | key, value | value.home? }
  end

  
  def point2sphere( point )
    @spheres[ point ]
  end

  
  def put_monster_near( monster, point )

    p_point = choose_dir_point( point ) do | check_point |
      monster_movable?( monster, check_point )
    end

    @monsters[ p_point ] = monster if p_point
    p_point
    
  end
  
  def monster_killed( monster, point )

    if monster
      @monsters.delete_if { | m_point, m_monster | monster == m_monster }
    elsif point
      @monsters.delete( point ) 
    end
    
  end

  alias_method( :monster_disappear, :monster_killed )
  

  def out_of_range?( point )

    row, col = point
    ( row < 0 ) || ( row > MAXY - 1 ) || ( col < 0 ) || ( col > MAXX - 1 )

  end
  
  # ƥüϷ( object )( row, col )֤뤳Ȥ뤫?
  
  def putable?( point )

    return false if out_of_range?( point )
    
    row, col = point
    ( @maze[ row ][ col ] == ONOTHING ) && !( @objects.key? point )

  end

  # ƥüϷ֤˷롣
  
  def fillroom( object_id, arg = nil )
    random_put( Larnobject.new( object_id, arg ) )
  end

  # numnilκݤˤϡְ֤ޤޤǥ롼ס
  # numꤵƤ顢βΤߡ
  
  def random_put( object, num = nil )
    
    row = rnd( MAXY-2 ) # .
    col = rnd( MAXX-2 ) # 

    i = 0
    
    loop do
      
      break if putable?( [ row, col ] ) # ־ꡣ
      
      row += rnd( 3 ) - 2
      row = 1        if ( row > MAXY - 2 )
      row = MAXY - 2 if ( row < 1 )

      col += rnd( 3 ) - 2
      col = 1        if ( col > MAXX - 2 )
      col = MAXX - 2 if ( col < 1 )

      return if num && ( ( i += 1 ) > num )
      
    end

    # ־꤬ޤäΤǡϥåϿ
    
    @objects[ [ row, col ] ] = object
    
  end

  
  def fillmroom( num, object_id, arg = 0 )
    num.times { fillroom( object_id, arg ) }
  end

  # Ψդfillroom
  def froom( n, object_id, arg = nil )
    fillroom( object_id, arg ) if ( rnd( 151 ) < n )
  end
    
  
  def create_town

    fillroom( OENTRANCE )  # /* entrance to dungeon */

    random_put( Larnobject.dndstore )
    random_put( Larnobject.school )

    fillroom( OBANK )      # /* 1st national bank of larn */
    fillroom( OVOLDOWN )   # /* volcano shaft to temple */
    fillroom( OHOME )      # /* the players home & family */
    fillroom( OTRADEPOST ) # /* the trading post */
    fillroom( OLRS )       # /* the larn revenue service */
        
  end

  # ϲµܤκǽǤ뤫лµܤκǽǤ뤫?
  # γˤϡ곬ʤʤɤ֤ʤ
  
  def bottom?
    ( @level == MAXLEVEL - 1 ) || ( @level == MAXLEVEL + MAXVLEVEL - 1 )
  end
  
  def make_trapdoor
    fillmroom( rund( 2 ),OIVTRAPDOOR ) unless bottom?
  end
  
  # 곬ʡ
  
  def make_stairsdown
    fillroom( OSTAIRSDOWN ) unless bottom?
  end

  # 곬ʡ

  def make_stairsup

    return if ( @level <= 1 ) # ĮˤϾס1ˤΤס
    return if ( @level == MAXLEVEL ) # лµ1ˤϼ̤Τס

    fillroom( OSTAIRSUP )
	  
  end

  def volcano?
    @level >= MAXLEVEL
  end

  # лµܤ줬ǽơ
  def final? ; volcano? && bottom? ; end

  # ФФޤ
  
  def make_gem

    rund( 2 ).times { random_put( Larnobject.newdiamond( @level ) ) }
    rund( 2 ).times { random_put( Larnobject.newruby( @level ) ) }
    rund( 2 ).times { random_put( Larnobject.newemerald( @level ) ) }
    rund( 2 ).times { random_put( Larnobject.newsapphire( @level ) ) } 

  end

  def make_potion
    ( rnd( 4 ) + 3 ).times { random_put( Larnobject.newpotion ) }
  end

  def make_scroll
    ( rnd( 5 ) + 3 ).times { random_put( Larnobject.newscroll ) }
  end

  def make_gold

    ( rnd( 12 ) + 11 ).times do 
      fillroom( OGOLDPILE, 12 * rnd( @level + 1 ) + ( @level << 3 ) + 10 )
    end

  end

  def make_book
    rund( 3 ).times { random_put( Larnobject.newbook( @level ) ) }
  end

  R_EXIT = MAXY - 1 # ιԿ
  C_EXIT = 33       # 
    
  def make_exit
    return unless @level == 1

    # /* exit from dungeon */
    @maze[ R_EXIT ][ C_EXIT ] = ONOTHING
    @objects[ [ R_EXIT, C_EXIT ] ] = Larnobject.new( OEXIT )
        
  end

  
  def makeobject

    if @level == START # Į饹( 0 )
      create_town
      return
    end

    make_exit

    
    # ϡ󥸥( @level >= 1 )
    
    # /* volcano shaft up from the temple */
    fillroom( OVOLUP ) if ( @level==MAXLEVEL )

    # /*      make the fixed objects in the maze STAIRS       */
    make_stairsdown
    make_stairsup
	  
    # /*      make the random objects in the maze             */
    # ƥФޤޤ
    
    make_book        # ѽ
    fillmroom( rund( 3 ),    OALTAR )       # š
    fillmroom( rund( 3 ),    OSTATUE )      # Ħ
    fillmroom( rund( 3 ),    OPIT )         # ܡ
    fillmroom( rund( 3 ),    OFOUNTAIN )    # 
    fillmroom( rnd( 3 ) - 2, OIVTELETRAP )
    fillmroom( rund( 2 ),    OTHRONE )      # ̺¡
    fillmroom( rund( 2 ),    OMIRROR      ) # 
    fillmroom( rund( 2 ),    OTRAPARROWIV )
    fillmroom( rnd( 3 ) - 2, OIVDARTRAP )
    fillmroom( rund( 3 ) ,   OCOOKIE )      # Υå
    
    fillmroom( ( @level == 1 ) ? 1 : rund( 2 ), OCHEST, @level ) # Ȣ
  
    make_trapdoor            # Ȥꡣ
    make_gem unless volcano? # С
    make_potion              # 
    make_scroll              # ʪ
    make_gold                # ⡣

    fillroom( OBANK2 ) if ( @level == 5 ) # /* branch office of the bank */


    froom( 2, ORING,            0 )         # /* a ring mail             */
    froom( 1, OSTUDLEATHER,     0 )         # /* a studded leather       */
    froom( 3, OSPLINT,          0 )         # /* a splint mail           */
    froom( 5, OSHIELD,          rund( 3 ) ) # /* a shield                */
    froom( 2, OBATTLEAXE,       rund( 3 ) ) # /* a battle axe            */
    froom( 5, OLONGSWORD,       rund( 3 ) ) # /* a long sword            */
    froom( 5, OFLAIL,           rund( 3 ) ) # /* a flail                 */
    froom( 4, OREGENRING,       rund( 3 ) ) # /* ring of regeneration    */
    froom( 1, OPROTRING,        rund( 3 ) ) # /* ring of protection      */
    froom( 2, OSTRRING,         4 )         # /* ring of strength + 4    */
    froom( 7, OSPEAR,           rnd( 5 ) )  # /* a spear                 */
    froom( 3, OORBOFDRAGON,     0 )         # /* orb of dragon slaying   */
    froom( 4, OSPIRITSCARAB,    0 )         # /* scarab of negate spirit */
    froom( 4, OCUBEofUNDEAD,    0 )         # /* cube of undead control  */
    froom( 2, ORINGOFEXTRA,     0 )         # /* ring of extra regen     */
    froom( 3, ONOTHEFT,         0 )         # /* device of antitheft     */
    froom( 2, OSWORDofSLASHING, 0 )         # /* sword of slashing       */
    
    # ꥸʥLarnǤϡBessman's flailing hammerνиΨޤˤ㤹
    # ٤Υץ쥤νиΨ4/151ǤϤޤˤ쥢
    # иΤɬ111Х?

    # unless @@bessmann 
    #  froom( 4, OHAMMER, 0 ) # /*Bessman's flailing hammer*/
    #  @@bessmann = true
    # end

    # RubyLarnꥸʥ롣
    # ٤Υץ쥤ǥϥޡΨϡ( 4/151 ) * 13

    # ٤㤯ꤵƤݤܡʥƥࡣ
    
    @@bessmann = true if !( @@bessmann ) && froom( 4, OHAMMER, 0 )

    if ( @level > 3 ) &&( $HARDGAME < 3 || rnd( 4 ) == 3 )
      froom( 3, OSWORD,      3    )      # /* sunsword + 3       */
      froom( 5, O2SWORD,     rnd( 4 ) )  # /* a two handed sword */
      froom( 3, OBELT,       4 )         # /* belt of striking   */
      froom( 3, OENERGYRING, 3 )         # /* energy ring        */
      froom( 4, OPLATE,      5 )         # /* platemail + 5      */
    end

  end

  # ϷŪpoint˰ưǤʤȡ
  # 󥹥ץ쥤䡼뤳ȤˤưǤʤ2̤꤬ޤ
  
  def movable?( player, point, map = false )

    return false if out_of_range?( point )
    
    row, col = point
    # ȴ(wtw?)ʤȤˤϡɤ̤ʤ
    return false if ( @maze[ row ][ col ] == OWALL ) && !( player.wtw? )
    return false if @players.key?( point ) && !map
    return false if @monsters.key?( point ) && !map

    true
    
  end

  # Distancemapѡ
  
  def monster_map_movable?( monster, point )
    monster_movable?( monster, point, true )
  end
  
  def monster_movable?( monster, point, map = false )

    return false unless movable?( monster, point, map )

    return true unless ( object = @objects[ point ] )

    # ĤɥݤˤϰưԲġ
    return false if object.closeddoor?

    # Хѥ϶ޤʤ?
    return false if monster.vampire? && object.mirror?

    return true unless monster.intelligent?

    # ʲƬΤ褤󥹥(intelligent?)ѤǤ
    # Ȥʤɤ櫤򤱤ޤ
    # ѸΤǤsphereˤ̤ͤùߤޤ

    return false if ( object.trap? && object.found? ) || ( object.pit? )

    true
      
  end

  DIR = [ ?h, ?j, ?k, ?l, ?y, ?u, ?b, ?n ]
  
  def random_point_near( point )
    next_point( point, DIR[ rand( DIR.size ) ] )
  end

  
  def choose_dir_point( point )

    offset = rnd( 8 )

    8.times do | i |
      n_point = next_point( point, DIR[ ( offset + i ) % 8 ] )
      return n_point if yield( n_point )
    end
    
    nil

  end

  def player_exist?( player )
    @players.value?( player )
  end
  
  def put_player_near( player, point )

    row, col = point
    
    # ꤵ줿 point ˡplayer֤Ǥ뤫ɤ?
    return point if movable?( player, point )

    # ꤵ줿ζ˵ˡplayer֤Ǥ뤫ɤ?
    return( choose_dir_point( point ) do | p_point | 
      movable?( player, p_point )
    end )
    
  end

  def teleport( player )

    @players.delete_if { | point, another | player == another }
    put_player_near( player, nil )

  end

  def teleport_monster( monster, num = 100 )

    @monsters.delete_if { | point, mon | mon == monster }
    random_put_monster( monster, num )

  end
  
  def random_put_monster( monster, num = 100 )

    i = 0
    
    loop do
      point = [ rand( MAXY ), rand( MAXX ) ]

      if monster_movable?( monster, point )
	@monsters[ point ] = monster
	return point
      end

      return nil if ( ( i += 1 ) >= ( num - 1 ) )
      
    end
    
  end

  def put_player( player, point )
    
    # ꤵ줿pointζ᤯˥ץ쥤䡼֤롣
    if point && ( new_point = put_player_near( player, point ) )
      @players[ new_point ] = player
      return new_point
    end

    loop do
      point = [ rand( MAXY ), rand( MAXX ) ]

      if movable?( player, point )
	@players[ point ] = player
	return point
      end
      
    end
    
  end # def put_player

  def put_monster( monster, point )

    return nil unless monster_movable?( monster, point )
    @monsters[ point ] = monster

  end
  
  def move_player( player, from, to )

    @players.delete( from )
    @players[ to ] = player
    
  end

  def move_monster( monster, from, to )

    # p from
    # p to
    
    @monsters.delete( from )  if from
    @monsters[ to ] = monster if to
    
  end
  

  def player2point( player )
    @players.invert[ player ]
  end

  def point2object( point )
    @objects[ point ]
  end

  def point2player( point )
    @players[ point ]
  end

  def point2monster( point )
    @monsters[ point ]
  end

  
  def nearbymonst?( player )
    return unless ( point = player2point( player ) )

    false
    
  end

  def lose_object( object )
    @objects.delete_if { | point, obj | obj == object }
  end

  def get_object( object, point )
    @objects[ point ] = object
  end

  def something

  end

  def distance( from, to )
    [ ( from[ 0 ] - to[ 0 ] ).abs, ( from[ 1 ] - to[ 1 ] ).abs ].max
  end

  # pointΥ1ʲΥ󥹥ȴФ
  def monsters_near( point )

    value = []

    @monsters.each do | m_point, monster |
      next if distance( m_point, point ) > 1 # ܤƤʤ
      value.push( monster ) 
    end
    
    value
    
  end

  def near_with_point( hash, point )

    value = hash.dup
    
    # ܤƤʤǤ
    value.delete_if { | h_point, h_obj |
      ( distance( h_point, point ) > 1 ) || ( if block_given? ; !yield( h_obj ) ; end )  }

    value.to_a

  end

  def players_near_with_point( point )
    near_with_point( @players, point )
  end

  
  def monsters_near_with_point( point )
    near_with_point( @monsters, point )
  end

  def objects_near_with_point( point )
    near_with_point( @objects, point )
  end

  # identify_trapѡ
  # pointܤƤơȯѤ櫤ʤ֤ޤ
  def traps_near_with_point( point )
    near_with_point( @objects, point ){ | obj | obj.trap? && obj.found? }
  end

  def wall?( point )
    @maze[ point[ 0 ] ][ point[ 1 ] ] == OWALL
  end

  def wall_crumbles?( point, dam )

    # ɤäơ᡼ʬǤ뤫ɤ
    wall?( point ) && ( dam >= 50 + $HARDGAME ) && !final?
    
  end

  def wall_crumbles( point )
    @maze[ point[ 0 ] ][ point[ 1 ] ] = ONOTHING
  end

  # rϿ᤭ФȾ¡
  def wall_crumbles_radius( point, r )

    ( point[ 0 ] - r ).upto( point[ 0 ] + r ) do | row |
      ( point[ 1 ] - r ).upto( point[ 1 ] + r ) do | col |

	next if out_of_range?( target_point = [ row, col ] )

	wall_crumbles( target_point )
	
      end

    end
    

  end # def wall_crumbles_radius

  def wall_crumbles_near( point )
    wall_crumbles_radius( point, 1 )
  end

  def wipeout_monsters
    @monsters.delete_if { | p, mon | Monster.genocided?( mon ) }
  end

  # Ϸ( maze )ΤߤѤޤ
  # sphereõ
  # objectmonster֡playerΰ֤Ѥޤ
  
  def alter_reality

    save_objects  = @objects.values
    save_monsters = @monsters.values

    @spheres.clear
    @objects.clear
    @monsters.clear
    
    # ϩ
    @maze = Doublearray.new( MAXY, MAXX,
			    ( @level == START ) ? ONOTHING : OWALL )

    # ϩڤȴ
    eat( 1, 1 ) unless @level == START

    reput_objects( save_objects )   # ƥ֡
    reput_monsters( save_monsters ) # ʪ֡

    nothing_for_players              # ץ쥤䡼ε򤯤ȴ
    
  end

  def reput_objects( save_objects )

    make_exit # иꡣ

    save_objects.each do | object |
      next if object.exit # иĤ⤤ʤ
      random_put( object, 100 )
    end

  end

  def reput_monsters( save_monsters )

    save_monsters.each do | monster |
      teleport_monster( monster, 100 )
    end

  end

  def nothing_for_players     
    @players.keys.each { | ( row, col ) | @maze[ row ][ col ] == ONOTHING }
  end

  def to_move_monsters( point, rows, cols )
  
    value = @monsters.dup

    p_row, p_col = point

    # ϰΥ󥹥ȴФޤ
    # ץ쥤䡼ι󥹥ϡưޤ
    
    value.delete_if do | ( m_row, m_col ), monster |
      !monster.wakeup? &&  ( ( p_row - m_row ).abs > rows || ( p_col - m_col ).abs > cols )
    end
    
    value.to_a

  end

  def intelligent_movable?( monster, point )
    monster_movable?( monster, point, true )
  end

  def nearest_player_length( m_point )

    return nil if out_of_range?( m_point )
    return nil if @players.empty? # ï⤤ʤ

    ( @players.keys.collect { | p_point | distance( m_point, p_point ) } ).min
 
  end

  def shaft_down
    return nil if @level != 0
    ( @objects.find{ | point, obj | obj.voldown? } )[ 0 ]
  end

  def shaft_up
    return nil if @level != 11
    ( @objects.find{ | point, obj | obj.volup? } )[ 0 ]
  end

  def add_monster
    random_put_monster( Monster.create( @level ), 5 )
  end

  
  def add_monsters( num = 1 )
    num.times { add_monster }
  end

  def fill_monsters
    return if @level == 0 # ˤϥ󥹥֤ʤ
    add_monsters( rnd( 12 ) + 2 + ( @level >> 1 ) )
  end

  def fill_monsters_reenter( player )
    add_monsters( @level >> 1 + 1 ) unless @already_join.include?( player ) 
  end

  def name2player( name )
    @players.values.find { | player | player.name == name }
  end

  def loadable?( name )
    name2player( name )
  end

  def all_traps_found
    @objects.each_value { | obj | obj.found if obj.trap?  }
  end
  
end

if $0 == __FILE__

  raise if ARGV.size != 2
  
  require "ncurses"
  
  include Ncurses
      
  begin
    
    Ncurses.initscr
    Ncurses.noecho
    Ncurses.cbreak

    srand
    cave = Cavelevel.new( ARGV[ 0 ].to_i, ARGV[ 1 ].to_i )

    cave.maze.each_with_index do | cellary, row |
      cellary.each_with_index do | cell, col |
	Ncurses.mvaddstr( row, col, "#" ) if cell != Constant::Object::ONOTHING
      end
    end

    cave.objects.each do | ( row, col ), obj |
      Ncurses.mvaddstr( row, col, Constant::Client::OBJCHAR[ obj.id ].chr )
    end

    
    Ncurses.getch

    Panel.update
    Ncurses.doupdate
    
  ensure

    Ncurses.endwin

  end

end
