class Database

  # Fileǡ١
  
  LOG_PATH       = "larn.log"  # 
  RANKING_LOSER  = "loser"     # 󥭥󥰡Լѡ
  RANKING_WINNER = "winner"    # 󥭥󥰡ѡ
  SAVE_PATH      = "%s.sav"    # ֥ե롣
  
  # logե롢󥭥󥰥ե롢saveեȤ⡢Ź沽Ƥޤ
  # Ƥޤȡ̵̣ʤΤǤ

  # ȤꤢŹ沽ʤǥȡ
  
  # KEY          = "Sona mi areru ec sancitu" 

=begin

  Log:

  CSVǤեɤϰʲΤȤꡢ

  "","̾",ޥ,

  ޥɤȰϰʲΤȤꡣ

  CHARGE    # 򥯥ꥢȡ˱Ƕݤޤ
  PAY       # Ƕλʧ
  SAVE    # 򥻡֤
  LOAD   ̵   # ɤ
  START   # 򳫻Ϥ
  WIN     # ( $HARDGAME )ǡ९ꥢ

  "Fri Mar 19 01:51:20 2004","saino",START,0

=end
  
  def initialize

    @charge   = Hash.new( 0 ) # ̾ => Ƕ
    @hardgame = Hash.new( 0 ) # ̾ => ꡣ
    @loadable = Hash.new( 0 ) # ̾ => ( ֤β - ɤβ )

    @winner   = []            # 1, 2, ...

    create_log_file
    create_ranking_loser
    create_ranking_winner
    
    log_file_parse

  end
  
  # ٤Ǥ⥯ꥢȤ뤫ɤ?
  def winner?( name ) 
    @winner.include?( name )
  end

  def create_log_file

    unless FileTest.exist?( LOG_PATH )
      open( LOG_PATH, "w+b" ) { }
    end

  end

  
  def log_file_parse

    File.foreach( LOG_PATH ) do | line |

      timestamp, name, command, argument = csv_split( line )

      case command
      when "CHARGE"
	@charge[ name ] += argument.to_i
      when "PAY"
      	@charge[ name ] -= argument.to_i
      when "SAVE"
   	# @loadable[ name ] += 1
	@hardgame[ name ]  = argument.to_i
      when "LOAD"	
      	# @loadable[ name ] -= 1
      when "WIN"
	winner_found( name, argument.to_i )
      end
	
    end

  end
  
  def save_file_exists?( name )
    FileTest.exist?( name2savefile( name ) )
  end

  def hardgame( name )
    @hardgame[ name ]
  end

  def to_load?( name )
    ( save_file_exists? name ) # && ( @loadable[ name ] == 1 )
  end

  def start( name, hardgame )
    log_start( name, hardgame )
    @hardgame[ name ] = hardgame
  end
  
  def load( name )

    gservers = nil
    
    # ɡ
    save_file_name = name2savefile( name )
    
    open( save_file_name, "r+b" ) do | file |
      gservers = Marshal.load( file.read )
    end

    # ɤλ顢ե
    File.delete( save_file_name )

    log_load( name ) # Ͽ
    # @loadable[ name ] -= 1

    gservers
    
  end

  def name2savefile( name )
    sprintf( SAVE_PATH, name )
  end

  def save( name, data, clear_hardgame )

    open( name2savefile( name ), "w+b" ) do | file |
      file.write( Marshal.dump( data ) )
    end
    
    log_save( name, clear_hardgame )
    
    # @loadable[ name ] += 1
    @hardgame[ name ]  = clear_hardgame
    
  end
  
  def charge( name, amount )

    log_charge( name, amount )
    @charge[ name ] += amount

  end

  def pay( name, amount )

    log_pay( name, amount )
    @charge[ name ] -= amount
    
  end

  def winner_found( name, clear_hardgame )
    
    @winner.push( name ) unless @winner.include?( name )
    @hardgame[ name ] = clear_hardgame + 1
    @hardgame[ name ] = 9 if @hardgame[ name ] > 9	
    
  end
  

  def win( name, clear_hardgame )

    log_win( name, clear_hardgame )
    winner_found( name, clear_hardgame )

  end

  def charge_amount( name )
    @charge[ name ]
  end

  # private

  def logging( format, *argument )
    
    open( LOG_PATH, "a+b" ) do | file |
      file.puts( sprintf( format, *argument ) )
    end
    
  end
  
  def log_charge( name, amount )
    logging( '"%s","%s",CHARGE,%d', Time.now.ctime, name, amount )
  end

  def log_save( name, clear_hardgame )
    logging( '"%s","%s",SAVE,%d', Time.now.ctime, name, clear_hardgame )
  end

  def log_start( name, clear_hardgame )
    logging( '"%s","%s",START,%d', Time.now.ctime, name, clear_hardgame )
  end

  def log_load( name )
    logging( '"%s","%s",LOAD', Time.now.ctime, name )
  end

  def log_pay( name, amount )
    logging( '"%s","%s",PAY,%d', Time.now.ctime, name, amount ) 
  end

  def log_win( name, clear_hardgame )
    logging( '"%s","%s",WIN,%d', Time.now.ctime, name, clear_hardgame )
  end

  # 󥭥Ͽ

  def create_ranking_loser

    unless FileTest.exist?( RANKING_LOSER )
      open( RANKING_LOSER, "w+b" ) { }
    end
    
  end

  def create_ranking_winner

    unless FileTest.exist?( RANKING_WINNER )
      open( RANKING_WINNER, "w+b" ) { }
    end

  end
  
  def ranking_for_loser( score, hardgame, name, string )

    # CSVǡ󥭥󥰥եɲý񤭹ߡ
    
    open( RANKING_LOSER, "a+b" ) do | file |
      file.puts( sprintf( '%d,%d,"%s","%s","%s"',
			 score, hardgame, name, string, Time.now.ctime ) )
    end
    
  end

  def ranking_for_winner( score, hardgame, mobuls, name )

    open( RANKING_WINNER, "a+b" ) do | file |
      file.puts( sprintf( '%d,%d,%d,"%s","%s"',
			 score, hardgame, mobuls, name, Time.now.ctime ) )
    end

  end

  def all_winners
    
    cvs_file_split( RANKING_WINNER ).sort do | ( score1, ), ( score2, ) |
      score2.to_i - score1.to_i
    end

  end

  def string2time( ctime )

    # ctimeϡ"Fri Apr  1 00:00:00 2004"ηǤ

    if ctime =~ /.{3} (.{3})\s+(\d+) (\d{2})\:(\d{2})\:(\d{2}) (\d{4})/
      Time.local( $6.to_i, $1, $2.to_i, $3.to_i, $4.to_i, $5.to_i )
    else
      puts ctime
      sleep 3
    end
    
  end
  
  def all_losers

    cvs_file_split( RANKING_LOSER ).sort do | rdata1, rdata2 |
      # rdata
      # [ score, hardgame, name, string, Time.now.ctime ]

      if rdata1[ 0 ] == rdata2[ 0 ]
	string2time( rdata2[ 4 ] ) - string2time( rdata1[ 4 ] )
      else
	rdata2[ 0 ].to_i - rdata1[ 0 ].to_i
      end

    end
    
  end

  def cvs_file_split( filename )

    all = []
    
    File.foreach( filename ) do | csv |
      all.push( csv_split( csv ) )
    end

    all

  end
  
  def winners_best( num = nil )
    num ? all_winners[ 0 .. ( num - 1 ) ] : all_winners
  end

  def losers_best( num = nil )
    num ? all_losers[ 0 .. ( num - 1 ) ] : all_losers
  end

  # CSVˡ
  # Ruby 122ڡΥѥǤ

  # CSVեɤʸѴ
  
  def csv_split( source, delimiter = ',' )

    csv = []
    qd = Regexp.quote( delimiter )

    source += delimiter
    source.scan(/(([^"#{qd}][^#{qd}]*|)|"(([^"]|"")*)")#{qd}/ ) do
      | match, m1, m2, *rests |
      if m2
	csv.push m2.gsub(/""/,'"')
      else
	csv.push m1
      end
      
    end
    
    csv

  end
  
  
end
