require "constant"
require "utility"
require "doublearray"

# pointεΥɽ롣
# @map[ row ][ col ] = 10ξ硢point[ row, col ]ޤǤκûΥ
# 10Ǥ롣

class Distancemap

  include Constant::Cavelevel
  include Utility
    
  def initialize
    # nilϵΥԳΰ̣
    @map = Doublearray.new( MAXY, MAXX, nil )
  end

  # ΥꤷƤ뤫ɤ
  def distance( point )
    return nil unless area?( point )
    @map[ point[ 0 ] ][ point[ 1 ] ]
  end

  def all_clear
    
    MAXY.times do | i |
      MAXX.times do | j |
	@map[ i ][ j ] = nil
      end
    end
    
  end
  
  def calculate( cave, monster, point, rows, cols, depth )

    # ľη̤
    all_clear
    
    # map٤ϰϤ׻
 
    # row
    @top    = [ point[ 0 ] - rows - 2, 0 ].max
    @bottom = [ point[ 0 ] + rows + 2, MAXY - 1 ].min
    
    # col
    @left  = [ point[ 1 ] - cols - 2, 0 ].max
    @right = [ point[ 1 ] + cols + 2, MAXX - 1 ].min

    # pointϵΥ׻νȯʤΤǡΥ0
    @map[ point[ 0 ] ][ point[ 1 ] ] = 0
        
    depth.times do | n |
      do_calculate( cave, monster, point, n )
    end

  end

  def do_calculate( cave, monster, point, depth )

    @top.upto( @bottom ) do | row |
      @left.upto( @right ) do | col |
	# row, colΥnumʤСμϤϵΥ ( num + 1 )
	fillmap_near( cave, monster, [ row, col ], depth + 1 ) if @map[ row ][ col ] == depth
      end
    end

  end

  DIRS = "hjklyubn"
  
  def fillmap_near( cave, monster, point, num )

    DIRS.each_byte do | dir |

      r,c = to_fill = next_point( point, dir )

      next unless area?( to_fill )   # ϰϳ
      next if distance( to_fill ) # Ǥ˵Υꡣ
      next unless cave.monster_map_movable?( monster, to_fill ) # ưԲġ
      
      @map[ r ][ c ] = num

    end

  end

  def area?( point )
    point[ 0 ].between?( 0, MAXY - 1 ) && point[ 1 ].between?( 0, MAXX - 1 )
  end

end
