module Scroll

  def pocket_read( client, point )

    player = client.player
    mesg   = player.mesg

    # timestop̵
    return false if player.timestop?
    
    # ɤޤ
    if player.blindcount?
      # 1560 "You can't read anything when you're blind!"
      message( client, mesg[ 1560 ] )
      return false # ˤϿʤ
    end
    
    # 1561 "What do you want to read [* for all] ? "
    # 1562 "aborted"
    
    choice = client.select( mesg[ 1561 ], player.list_readable,
			   mesg[ 152 .. 154 ], mesg [ 1562 ] )

    return true if choice == ?\e  # 󥻥ˡ

    if !( object = player.pocket( choice ) )
      # 1563 "You don't have item %c!"
      message( client, mesg[ 1563 ], choice )
    elsif !object.readable?
      # 1564 "There's nothing on it to read"
      message( client, mesg[ 1564 ] )
    elsif object.book?
      player.lose_item( object )
      do_readbook( client, object )
    elsif object.scroll?
      player.lose_item( object )
      do_readscroll( client, object, point )
    end

    true # ꡣ
    
  end
  
  def oscroll( client, object, point )
    
    player = client.player
    mesg   = player.mesg
    
    answer = reach_question( client,
			    sprintf( mesg[ 311 ], player.objectname( object ) ), 
			    ( player.blindcount? ? mesg[ 315 ] : mesg[ 314 ] ),
			    { ?\e => mesg[ 318 ], ?i  => mesg[ 318 ],
			      ?r  => mesg[ 316 ],
			      ?t  => mesg[ 317 ], } )

    case answer
    when ?r
      readscroll( client, object, point )
    when ?t
      take( client, object, point )
    end
    
  end
  
  def obook( client, object, point )
    
    player = client.player
    mesg   = player.mesg
    
    answer = reach_question( client, mesg[ 161 ],
			    mesg[( player.blindcount? ? 163 : 162 ) ],
			    { ?\e => mesg[ 164 ], # ̵롣
			      ?i  => mesg[ 164 ], # ̵롣
			      ?r  => mesg[ 165 ], # ѽɤࡣ
			      ?t  => mesg[ 166 ], # ꡣ
			    } )
    
    case answer
    when ?r
      readbook( client, object, point )
    when ?t
      take( client, object, point )
    end
    
  end
  
  
  def readbook( client, object, point )
    
    return if client.player.blindcount?
    
    do_readbook( client, object )
    lose_object( client, object, point )
    
  end
  
  def do_readbook( client, object )
    
    player = client.player
    mesg   = player.mesg
    
    player.learn_spell_id( object.arg )
    message( client, mesg[ 167 ], object.spelcode, mesg[ 170 + object.arg ] )
    message( client, mesg[ 210 + object.arg ] )
    
    if ( rnd( 10 ) == 4 )
      player.intelligence_up
      message( client, mesg[ 168 ] )
    end
    
  end
  
  def enchant_armor( client )

    player = client.player
    mesg   = player.mesg

    ac = player.ac      # ѥåפɸϡ
    player.enchant_armor # ɶΰϥåס

    if ( ac == player.ac )
      message( client, mesg[ 651 ] )
    else
      message( client, mesg[ 650 ] )
    end
    
  end

  def enchant_weapon( client )

    player = client.player
    mesg   = player.mesg

    if player.wield?
      message( client, mesg[ 655 ] )
      player.enchant_weapon
    else
      message( client, mesg[ 656 ] )
    end
      
  end

  def enlightenment( client, point )

    message( client, client.player.mesg[ 657 ] )
    showcell_radius( client, point, 7 )

  end

  def blank_paper( client )
    message( client, client.player.mesg[ 658 ] )
  end

  def create_monster( client, level, point )
    put_monster_near( client, Monster.create( level ), point )
  end

  
  def readscroll( client, object, point )  # pointϥץ쥤䡼θ߰֡

    return if client.player.blindcount?
    
    lose_object( client, object, point )
    do_readscroll( client, object, point )
    
  end

  def create_artifact( client, point )
    something( client, point, @level )
  end
  
  def aggravate_monster( client )
    client.player.get_aggravate( 800 )
  end

  def time_warp( client )

    player = client.player
    mesg   = player.mesg
    
    gtime =  rnd( 1000 ) - 850

    message( client, ( ( gtime > 0 )? mesg[ 659 ] : mesg[ 660 ] ),
	    ( ( gtime + 99 ) / 100 ).abs )

    player.time_warp( gtime )

  end

  def expanded_awareness( client, point )

    client.player.get_awareness( 1800 )
    showcell( client, point )

  end

  def haste_monsters( client )
    client.player.get_hastemonst
  end

  # Ʊ쳬ؤΥ󥹥HPޤ
  def monster_healing
    @cavelevel.monsters.values.each { | monster | monster.healing }
  end

  def spirit_protection( client )
    client.player.get_spiritpro
  end

  def undead_protection( client )
    client.player.get_undeadpro
  end

  def stealth( client )
    client.player.get_stealth
  end

  def magic_mapping( client )

    message( client, client.player.mesg[ 661 ] )
    showall( client )

  end

  def hold_monsters( client )
    client.player.get_holdmonst( 30 )    
  end

  def gem_perfection( client )
    client.player.gem_perfection
  end

  def spell_extension( client )
    client.player.spell_extension
  end

  def all_identify( client )
    client.player.all_identify
  end

  def remove_curse( client )
    client.player.remove_curse
  end

  # point濴ˡΥ1Υ󥹥Ǥޤ
  def annihilation( client, point )
    
    player = client.player
    mesg   = player.mesg

    exp = 0
    
    ( @cavelevel.monsters_near_with_point( point ) ).each do | m_point, monster |

      if monster.anti_anihilation
	message( client, mesg[ 662 ], player.real_monstername( monster ) )
	monster.annihilated # HPȾ
      else
	exp += monster.experience  # иͳ
	@cavelevel.monster_killed( monster, m_point )
      end

    end
      
    if exp > 0 # 󥹥...
      message( client, mesg[ 663 ] )
      raiseexperience( client, exp ) # ޤȤƷиͥåס
      showcell( client, point ) # 蹹ϰ٤ǽʬ
    end

  end

  def pulverization( client, point )

    player = client.player
    
    go_direct( client, point, spell = Spell::SPELL.pulverization,
	      player.spell_might( spell ), player.mesg[ 666, 674 ] )
	      
  end

  def life_protection( client )
    client.player.get_lifeprot
  end
  
        
  def do_readscroll( client, object, point )

    client.player.identify( object ) # ʪ̡
    
    if object.enchant_armor?
      enchant_armor( client )
    elsif object.enchant_weapon?
      enchant_weapon( client )
    elsif object.enlightenment?
      enlightenment( client, point )
    elsif object.blank_paper?
      blank_paper( client )
    elsif object.create_monster?
      create_monster( client, @level + 1, point ) # ĲγؤΥ󥹥
    elsif object.create_artifact?
      create_artifact( client, point )
    elsif object.aggravate_monsters?
      aggravate_monster( client )
    elsif object.time_warp?
      time_warp( client )
    elsif object.teleportation?
      teleport( client )
    elsif object.expanded_awareness?
      expanded_awareness( client, point )
    elsif object.haste_monsters?
      haste_monsters( client )
    elsif object.monster_healing?
      monster_healing
    elsif object.spirit_protection?
      spirit_protection( client )
    elsif object.undead_protection?
      undead_protection( client )
    elsif object.stealth?
      stealth( client )
    elsif object.magic_mapping?
      magic_mapping( client )
    elsif object.hold_monsters?
      hold_monsters( client )
    elsif object.gem_perfection?
      gem_perfection( client )
    elsif object.spell_extension?
      spell_extension( client )
    elsif object.identify?
      all_identify( client )
    elsif object.remove_curse?
      remove_curse( client )
    elsif object.annihilation?
      annihilation( client, point )
    elsif object.pulverization?
      pulverization( client, point )
    elsif object.life_protection?      
      life_protection( client )
    end

  end

end
