=begin
  
  SDLcurses
  Ruby/SDLˤʰRuby/Ncurses饤֥  

  ʿ: 饤ȥ쥤
          BOLDͭʺݤˤϡ

  طʿ: 
          BLINKͭʺݤˤϡ쥤

  Υ饤֥ϡʤʡ

=end 

require "sdl"
require "kconv"

module SDLcurses

  SDL.init( SDL::INIT_VIDEO )
  
  if $KAPPA20
    ZENKAKU  = "10x20rkb.bdf"
    HANKAKU  = "k20b.bdf"
    FONTSIZE = 20
  else
    ZENKAKU  = "shnmk16minb.bdf"
    HANKAKU  = "shnm8x16rb.bdf" 
    FONTSIZE = 16
  end
  
#  ZENKAKU = "jiskan24-2000-1.bdf"
#  HANKAKU  = "jiskan24-2000-2.bdf"
#  HANKAKU   = "shnm8x16rb.bdf"
#  FONTSIZE = 24
  
  FONT = SDL::Kanji.open( ZENKAKU, FONTSIZE )
  FONT.add( HANKAKU )

  SDL::Key.enable_key_repeat(100,100)
  
  FONT.set_coding_system( SDL::Kanji::SJIS )
  
  LINES = 25
  COLS  = 80

  FONT_X = FONTSIZE / 2
  FONT_Y = FONTSIZE
  
  SCREEN = SDL.setVideoMode( COLS * FONT_X, LINES * FONT_Y, 16,
			    $FULLSCREEN ?  SDL::SWSURFACE | SDL::DOUBLEBUF | SDL::FULLSCREEN : SDL::SWSURFACE | SDL::DOUBLEBUF )
  
  SDL::Mouse.hide
  SDL::WM.setCaption( "RubyLarn 1.1.0", "RubyLarn 1.1.0" )
    
  # The following definitions are from PDCurses 2.6.
  
  COLOR_BLACK   = 0
  COLOR_RED     = 1
  COLOR_GREEN   = 2
  COLOR_YELLOW  = 3
  COLOR_BLUE    = 4
  COLOR_MAGENTA = 5
  COLOR_CYAN    = 6
  COLOR_WHITE   = 7

  COLOR_DARK_GRAY  = 8
  COLOR_LIGHT_GRAY = 9
  
  COLORS       = 0
  COLOR_PAIRS  = 0
  
  A_NORMAL      =  0x00000000
  A_UNDERLINE   =  0x00100000
  A_REVERSE     =  0x00200000
  A_BLINK       =  0x00400000
  A_BOLD        =  0x00800000
  A_RIGHTLINE   =  0x00010000
  A_DIM         =  0x00020000
  A_ALTCHARSET  =  0x00040000
  A_INVIS       =  0x00080000
  A_ATTRIBUTES  =  0xFFFF0000
  A_CHARTEXT    =  0x0000FFFF
  A_COLOR       =  0xFF000000

  A_LEFTLINE    =  A_DIM
  A_ITALIC      =  A_INVIS
  A_STANDOUT    =  ( A_BOLD | A_REVERSE )
  A_PROTECT     =  ( A_UNDERLINE | A_LEFTLINE | A_RIGHTLINE )

  KEY_RESIZE = 0632
  
  
  # color => [ r, g, b ]
  RGB = {
  
    COLOR_BLACK      => [   0,   0,   0 ],
    COLOR_RED        => [ 255,   0,   0 ],
    COLOR_GREEN      => [   0, 255,   0 ],
    COLOR_YELLOW     => [ 255, 255,   0 ],
    COLOR_BLUE       => [   0,   0, 255 ],
    COLOR_MAGENTA    => [ 255,   0, 255 ],
    COLOR_CYAN       => [   0, 255, 255 ],
    COLOR_WHITE      => [ 255, 255, 255 ],
    COLOR_DARK_GRAY  => [  82,  82,  82 ],
    COLOR_LIGHT_GRAY => [ 162, 162, 162 ],
      
  }

  def SDLcurses.initscr
    SDL::Event2.enableUNICODE
  end

  def SDLcurses.endwin

  end

  def SDLcurses.flushinp
    
    while event = SDL::Event2.poll
      
      case event
      when SDL::Event2::Quit
	exit
      end
      
    end
    
  end

  def SDLcurses.scrollok( win, bool )
    win.scrollok( bool )
  end
  
  def SDLcurses.cbreak

  end

  def SDLcurses.noecho


  end
  
  def SDLcurses.beep

  end

  def SDLcurses.has_colors?       ; false ; end
  def SDLcurses.can_change_color? ; false ; end
  def SDLcurses.start_color       ; false ; end


  def SDLcurses.COLOR_PAIR( n )  ;   ; end
  def SDLcurses.PAIR_NUMBER( a ) ;   ; end

  def SDLcurses.init_pair( num, fg_color, bg_color ) ;  ; end
  def SDLcurses.init_color( num, r, g, b )           ;  ; end
  def SDLcurses.keypad( window, bool )               ;  ; end

 
  def SDLcurses.nodelay( window, bool )

  end

  def SDLcurses.wattron( window, attribute )
    window.attron( attribute )
  end

  def SDLcurses.wattroff( window, attribute )
    window.attroff( attribute )
  end

  def SDLcurses.wstandout( window )
    window.standout
  end

  def SDLcurses.wstandend( window )
    window.standend
  end
  
  def SDLcurses.wattrset( window, attribute )
    window.attrset( attribute )
  end

  def SDLcurses.scroll( window )
    window.scrl( 1 )
  end

  def SDLcurses.wscrl( window, num )
    window.scrl( num )
  end

  def SDLcurses.mvwaddstr( window, row, col, string )
    window.mvaddstr( row, col, string )
  end

  def SDLcurses.wmove( window, row, col )
    window.move( row, col )
  end

  def SDLcurses.waddstr( window, string )
    window.addstr( string )
  end

  def SDLcurses.mvwaddch( window, row, col, char )
    window.mvaddch( row, col, char )
  end
  
  def SDLcurses.werase( window )
    window.erase
  end

  def SDLcurses.wclrtoeol( window )
    window.clrtoeol
  end
  
  
  class WINDOW

    @@cursor = 1 # visible

    # 
    @@cursor_surface = SDL::Surface.new( SDL::SWSURFACE,
					FONT_X, FONT_Y, SCREEN )
   # @@cursor_surface.set_alpha( SDL::SRCALPHA | SDL::RLEACCEL, 64 )
    @@cursor_surface.fillRect( 0, 0, FONT_X, FONT_Y, RGB[ COLOR_YELLOW ] )

    @@update_lines = []
    
    attr_reader :surface, :maxx, :maxy

    def initialize( rows, cols, roff, coff, surface = nil )
      
      @roff = roff
      @coff = coff

      if ( rows == 0 ) && ( cols == 0 ) && ( roff == 0 ) && ( coff == 0 )
	@rows = LINES
	@cols = COLS
      else
	@rows = rows
	@cols = cols
      end

      @strings = []

      @rows.times { @strings.push( " " * @cols ) }
            
      raise if ( @rows == 0 ) || ( @cols == 0 )

      @maxx       = @cols * FONT_X
      @maxy       = @rows * FONT_Y
      @attribute  = 0

      @surface = SDL::Surface.new( SDL::SWSURFACE, @maxx, @maxy, SCREEN ) unless surface
      
      @cursor = [ 0, 0 ]

      @nodelay = false
      @scroll  = false

      # 蹹ΰ( ñ )
      update_all_lines
            
    end

    def update_all_lines
      @rows.times { | row | @@update_lines[ row + @roff ] = true }
    end
    
    def update_current_line
      @@update_lines[ @cursor[ 0 ] + @roff ] = true
    end
    
    def scrollok( bool )
      @scroll = bool
    end
    
    def nodelay( bool )
      @nodelay = bool
    end

    def standout
      attrset( A_STANDOUT )
    end

    def standend
      @attribute &= ~A_STANDOUT
    end

    def offsetx
      @coff * FONT_X
    end

    def offsety
      @roff * FONT_Y
    end

    def attrset( attr )
      @attribute = attr
    end

    def attron( attr )
      @attribute |= attr
    end
      
    def attroff( attr )
      @attribute &= ~attr
    end

    def addstr( string )
      
      string = Kconv.tosjis( string )
      return if string.size == 0
      
      @surface.fillRect( col2x, row2y, string.size * FONT_X, FONT_Y, RGB[ bg_color ] )
      FONT.put( @surface, string, col2x, row2y, *RGB[ fg_color ] )

      @cursor[ 1 ] += string.size
      @cursor[ 1 ]  = @cols - 1 if ( @cursor[ 1 ] >= @cols ) 

      update_current_line
      
    end
    
    def fg_color
      
      if ( @attribute & A_REVERSE == A_REVERSE )
	( @attribute & A_BLINK == A_BLINK ) ? COLOR_DARK_GRAY : COLOR_BLACK
      else
	( @attribute & A_BOLD == A_BOLD ) ? COLOR_WHITE : COLOR_LIGHT_GRAY
      end
      	
    end

    def bg_color
      
      if !( @attribute & A_REVERSE == A_REVERSE )
	( @attribute & A_BLINK == A_BLINK ) ? COLOR_DARK_GRAY : COLOR_BLACK
      else
	( @attribute & A_BOLD == A_BOLD ) ? COLOR_WHITE : COLOR_LIGHT_GRAY
      end
    
    end
    
    def col2x
      @cursor[ 1 ] * FONT_X
    end

    def row2y
      @cursor[ 0 ] * FONT_Y
    end

    private :fg_color, :bg_color, :col2x, :row2y


    def move( row, col )
      raise if !row.between?( 0, @rows - 1 ) || !col.between?( 0, @cols - 1 )
      update_current_line
      @cursor = [ row, col ]
      update_current_line
    end

    def mvaddstr( row, col, string )
      move( row, col )
      addstr( string )
    end
    
    def mvaddch( row, col, char )
      move( row, col )
      addch( char )
    end

    def addch( char )
      addstr( char.chr )
    end


    def erase
      update_all_lines
      @surface.fillRect( 0, 0, @maxx, @maxy, COLOR_BLACK )
    end

    def clrtoeol
      update_current_line
      @surface.fillRect( col2x, row2y, @maxx, FONT_Y, COLOR_BLACK )
    end
    
    alias_method( :clear, :erase )

    def getch

#      loop do
#	
#	while event = SDL::Event2.poll
#	  
#	  case event
#	  when SDL::Event2::Quit
#	    exit
#	  when SDL::Event2::KeyDown
#	    unless ( input = event.unicode ) == 0 ; return( input ) ; end
#	  else
#	    	    
#	  end
#	
#	end
#     
#	return 0 if @nodelay
#	
    #  end

=begin
  SDL::Event2.waitϡ԰ꤹ
  SDL::Event2.pollϡŤ
=end
      
       loop do
	
	while event = SDL::Event2.poll
	  
	  case event
	  when SDL::Event2::Quit
	    exit
	  when SDL::Event2::KeyDown
	    unless ( input = event.unicode ) == 0 ; return( input ) ; end
	  else
	    	    
	  end
	
	end
      
	return 0 if @nodelay
	sleep 0.1
	
      end
      
    end

    def getyx( row = nil, col = nil )
      row[ 0 ] = @cursor[ 0 ] if row
      col[ 0 ] = @cursor[ 1 ] if col
      @cursor
    end
    
    def keypad( bool )
      
    end

    def scrl( n = 1 )

      return if !@scroll || ( n == 0 )

      if ( n.abs >= @rows )
	erase
      elsif n < 0

      elsif n > 0
	SDL.blit_surface( @surface, 0, FONT_Y * n, COLS*FONT_X, LINES*FONT_Y,
			 @surface, 0, 0 )
	@surface.fillRect( 0,  FONT_Y* ( @rows - n ), COLS*FONT_X, n.abs * FONT_Y,
			   RGB[ COLOR_BLACK ] )

      end

      update_all_lines
      
    end

    # num:
    # 0: invisible
    # 1: normal
    # 2: very visible
    
    def curs_set( num )
      old = @@cursor
      @@cursor = num
      update_all_lines
      old
    end

    def draw_cursor
      
      return if @@cursor == 0
      
      SDL.blit_surface( @@cursor_surface, 0, 0, FONT_X, FONT_Y, SCREEN,
		       ( @cursor[ 1 ] + @coff ) * FONT_X,
		       ( @cursor[ 0 ] + @roff ) * FONT_Y )
      
    end

    def to_update
      
      min = 100
      max = 0

      @@update_lines.each_with_index do | bool, i |
	return unless bool
	min = i if min > i
	max = i if max < i
      end

      return nil if min == 100
      
      [ 0, min * FONT_Y, COLS * FONT_X, ( max - min + 1 ) * FONT_Y ] 

    end

    def clear_update_lines
      @@update_lines.clear
    end
    
  end

  STDSCR = WINDOW.new( 0, 0, 0, 0, @surface )
  
  def SDLcurses.doupdate
   SCREEN.flip
  #  SCREEN.update_rect( *STDSCR.to_update ) if STDSCR.to_update
  #  STDSCR.clear_update_lines
  end
  
  def SDLcurses.stdscr
    STDSCR
  end

  def SDLcurses.getch
    STDSCR.getch
  end

  def SDLcurses.erase
    STDSCR.erase
  end
  
 

  def SDLcurses.curs_set( num )
    STDSCR.curs_set( num )
  end
      
  module Panel

    PANELS = []
    
    class PANEL

      attr_reader :window

      def initialize( window )
	
	raise if !window || !window.is_a?( WINDOW )

	@hide = false
	PANELS.push( self )
	@window = window

      end

      def del
	PANELS.delete( self )
	@window.update_all_lines
      end

      alias_method( :delete, :del )
      
      def replace( window )
	@window.update_all_lines
	@window = window
	@window.update_all_lines
      end
      
      def show
	@hide = false
	PANELS.delete( self )
	PANELS.push( self )
	@window.update_all_lines
      end

      def hide
	@hide = true
	@window.update_all_lines
      end
    
      def hidden?
	@hide
      end
      
      def move( row, col )

	
      end

      def bottom
	PANELS.delete( self )
	PANELS.unshift( self )
	@window.update_all_lines
      end

      def top
	PANELS.delete( self )
	PANELS.push( self )
	@window.update_all_lines
      end

      def above

      end

      def below

      end

    end
    
    def Panel.update
      
      SDLcurses.erase

      top_panel = nil

      # γؤΥѥͥ뤫ˡScreen˲žƤ
      
      PANELS.each do | panel |
	next if panel.hidden?
	window = panel.window
	SDL.blitSurface( window.surface, 0, 0,
			window.maxx, window.maxy, SCREEN,
			window.offsetx, window.offsety )
	top_panel = panel
	
      end
      
      # 򲫿
      top_panel.window.draw_cursor if top_panel
  
    end # class PANEL
            
  end # module Panel

end
